#include "mic.h"
#include "delay.h"
#include "motor.h"
uchar mic1;
uchar mic2;
uchar mic3; 
uchar threshhold1;
uchar threshhold2;
uchar threshhold3;
bit jump;

void mic_init(void){
        mic1=0;mic2=0;mic3=0;
        threshhold1=0;
        threshhold2=0;
        threshhold3=0;
	MicDataIn=0xFF;
	adcWR=1;
	adcRD1=1;adcRD2=1;adcRD3=1;
	Int1=1;
	Int2=1;
	Int3=1;
	//P3=0xFF;	
	return;

}		




void mic_cont_check(void){
        uchar j;
        uchar t1=0; 
        uchar t2=0; 
        uchar t3=0;
        for (j=0; j<4; j++)
        {
        mic_check();
        t1=t1+mic1/4;
        t2=t2+mic2/4;
        t3=t3+mic3/4;
        }
        
        mic1=t1; mic2=t2; mic3=t3;
}
        


void mic_check(void){
        bit r1=0; 
        bit r2=0;
        bit r3=0;
	adcWR=0; 
	adcWR=1;
while(r1==0||r2==0||r3==0){
	if(Int1==0){
		PortSelect1=0;
		PortSelect0=0;
		adcRD1=0; //Read data
		r1=1;
		mic1=MicDataIn; 
		adcRD1=1;
	}
	if(Int2==0){
		PortSelect1=0;
		PortSelect0=1;
		adcRD2=0; //Read data
		r2=1;
		mic2=MicDataIn;
		adcRD2=1;
	}
	if(Int3==0){
		PortSelect1=1;
		PortSelect0=0;
		adcRD3=0; //Read data
		r3=1;
		mic3=MicDataIn;
		adcRD3=1;
	}
  }   
 return; 
}

		




void mic_sampleEnvironment(void){
	uchar i;
	threshhold1=0;
	threshhold2=0;
	threshhold3=0;
	
	for (i=0; i<10; i++){
	   mic_check();
	 //  threshhold1=threshhold1+mic1;
	 //  threshhold2=threshhold2+mic2;
	 //  threshhold3=threshhold3+mic3;
	   if(threshhold1<mic1) threshhold1=mic1;
	   if(threshhold2<mic2) threshhold2=mic2;
	   if(threshhold3<mic3) threshhold3=mic3;
	}
//	threshhold1=threshhold1/10;
//	threshhold2=threshhold2/10;
//	threshhold3=threshhold3/10;
	
}


/*---------------------------------------

              (4)

mic1 (1)             mic2 (2)
         


	   mic3 (3)





/*---------------------------------------

 mic2 (1)             mic3 (2)
         


		  
             mic1 (3)

----------------------------------------*/
void testResponse(void){
	if(mic1<threshhold1+50 && mic2<threshhold2+50 && mic3<threshhold3+50) {return;}
	if (mic2>mic1 && mic3>mic1 && mic2<mic3+50 && mic3<mic2+50) {
	       motor_forward_s(3);
	       delay_s(2);
	       return;} //forward 
	
	if (mic1>mic2+50 && mic1>mic3+50 ){ 
	       motor_backward_s(3);
	       delay_s(2);
	       return; } //back
	if (mic2>mic3 && mic1>mic3 && mic2<mic1+50 && mic1<mic2+50) {
	       motor_left_s(3);
	       delay_s(2);
	       motor_forward_s(2);
	       delay_s(2);
	       return;} //southeast
	if (mic3>mic2 && mic1>mic2 && mic3<mic1+50 && mic3<mic1+50) {
	       motor_right_s(3);
	       delay_s(2);
	       motor_forward_s(2);
	       delay_s(2);
	       return;} //southwest 
	if (mic2>mic3+50 && mic2>mic1+50 ){ 
	         motor_left_s(2);
	         delay_s(2);
	         motor_forward_s(3);
	         delay_s(2);
	        return; } //left
	if (mic3>mic1+50 && mic3>mic2+50 ){ 
	         motor_right_s(2);
	         delay_s(2);
	         motor_forward_s(3);
	         delay_s(2);
	         return; 
	         } //right
	
	//else P1=0xFF; 
	return;
	
}

