#ifndef _ULTRASOUND_H_  
#define _ULTRASOUND_H_ 

#include <AT89X51.H>
#include "delay.h"
#include "setting8255.h"

#define USGeneratePort P1_7
#define USDetectPort P3_4


#define uchar unsigned char
#define uint unsigned int
#define ulong unsigned long


void ultrasound_tx(uchar period_us);

void ultrasound_on(void);
								
void ultrasound_off(void);

unsigned int ultrasound_time(void);

uint ultrasound_everageTime(void);

uchar ultrasound_distance(void);

bit ultrasound_obstacle(void);


#endif
