

#ifndef _MIC_H_
#define _MIC_H_

#include <AT89X51.H>
//#include <AT89X55.H>

#define uchar unsigned char

// Data from 8255
#define MicDataIn P0

#define adcWR P2_0

//PortSelect1 and PortSelect2 select which port to read
//"00" Port A, "01" Port B, "10" Port C, "11" for control signal use 8255 as multiplexer


//Int1,2,3----> ADC1,2,3's interrupt */
#define Int1 P2_1
#define Int2 P2_2
#define Int3 P2_3
#define adcRD1 P2_4
#define adcRD2 P2_5
#define adcRD3 P2_6

#define PortSelect1 P2_7
#define PortSelect0 P3_7


//=====function declaration===================================================================
//functions are begin with "mic_" here, though they are written for ADC or 8255 instead of mic

void mic_init(void);	
void mic_sampleEnvironment(void);
void mic_check(void);	
void mic_cont_check(void);
void testResponse(void);
#endif
