/******************************************
HKUST ELEC254 Project - Summer 2008
Sound Controlled Car
Group #4: Wang Zhen, Zhu Shucheng, Zhuo Wei
Author: Wang Zhen
******************************************/

#ifndef _SETTING8255_H
#define _SETTING8255_H

#include <AT89X51.H>
#include "delay.h"

//pin definition
#define RST_8255 P3_3
#define WR_8255 P3_0
#define A0 P3_6
#define A1 P3_5
#define DataBus P1

//function definition
void motor_LCD_8255_initial();	//initialization
void motor8255();				//setting for motor
void LCD8255_bus();				//setting for LCD data bus
void LCD8255_control();			//setting for LCD control

void LED8255_initial();
void LED8255_on();
void LED8255_off();
void LED8255_menu();
void LED8255_mode1();
void LED8255_mode2();
void LED8255_mode3();


#endif